# coding: utf-8

"""
    MoneyKit API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations

import json
import pprint
import re  # noqa: F401

from pydantic import BaseModel, Field, StrictStr, conlist

from moneykit.models.transaction import Transaction


class Transactions1(BaseModel):
    """
    list of created, updated and removed transactions.
    """

    created: conlist(Transaction) = Field(
        ..., description="A list of transactions that have been added to the link ordered by ascending datetime."
    )
    updated: conlist(Transaction) = Field(
        ..., description="A list of transactions that have been updated on the link ordered by ascending datetime."
    )
    removed: conlist(StrictStr) = Field(
        ..., description="A list of transaction ids that have been removed from the link ordered by ascending datetime."
    )
    __properties = ["created", "updated", "removed"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Transactions1:
        """Create an instance of Transactions1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in created (list)
        _items = []
        if self.created:
            for _item in self.created:
                if _item:
                    _items.append(_item.to_dict())
            _dict["created"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in updated (list)
        _items = []
        if self.updated:
            for _item in self.updated:
                if _item:
                    _items.append(_item.to_dict())
            _dict["updated"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Transactions1:
        """Create an instance of Transactions1 from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Transactions1.parse_obj(obj)

        _obj = Transactions1.parse_obj(
            {
                "created": [Transaction.from_dict(_item) for _item in obj.get("created")]
                if obj.get("created") is not None
                else None,
                "updated": [Transaction.from_dict(_item) for _item in obj.get("updated")]
                if obj.get("updated") is not None
                else None,
                "removed": obj.get("removed"),
            }
        )
        return _obj
